
WaitingAnimationTimeout = 250
LoadUrl = 'coverselle-load.php'

OptimalItemOverlap = 80
CoverselleOffset = 280

isTouchDevice = () ->

	# ('ontouchstart' in window) or (navigator.MaxTouchPoints > 0) or (navigator.msMaxTouchPoints > 0)
	typeof document.documentElement.ontouchstart != 'undefined'

itemClick = (event) ->

	item = jQuery(event.target).closest('item')

	thisItem = jQuery(item)

	if thisItem.hasClass('ready_for_click') or not isTouchDevice()
		link = thisItem.data('link')
		# window.location = link

itemHide = (item) ->

	thisItem = jQuery(item)

	Coverselle = jQuery(thisItem.closest('.Coverselle'))

	thisItem.parent().find('item.this').removeClass('this ready_for_click').unbind('click')

itemShow = (item) ->

	itemHide(item)

	thisItem = jQuery(item)

	Coverselle = jQuery(thisItem.closest('.Coverselle'))

	thisItem.removeClass().addClass('this dist0').bind('click',itemClick)

	nextItem = thisItem
	prevItem = thisItem

	itemCount = 0

	loop
		itemCount++
		prevItem = prevItem.prev('item')
		nextItem = nextItem.next('item')
		break unless prevItem.length or nextItem.length
		prevItem.removeClass().addClass('prev dist'+itemCount) if prevItem.length
		nextItem.removeClass().addClass('next dist'+itemCount) if nextItem.length
	
	setTimeout ->
		thisItem.addClass('ready_for_click')
	, 500

evalShowItemsCount = (Coverselle) ->

	coverselleWidth = Coverselle.width()
	ShowItems = Math.round 1 + ( coverselleWidth - CoverselleOffset ) / OptimalItemOverlap
	Coverselle.data('ShowItems',ShowItems)

resize = (Coverselle) ->

	coverselleWidth = Coverselle.width()
	itemsCount = Coverselle.data('ShowItems')
	realItemsCount = Coverselle.find('.box.active item').length
	itemWidth = Math.min 130, Math.round ( coverselleWidth - CoverselleOffset ) / ( realItemsCount - 1 )
	itemMargin = - ( 160 - itemWidth )
	# Coverselle.data('margin',itemMargin)
	Coverselle.find('item:not(:first-child)').css('margin-left',itemMargin)

initData = (Coverselle) ->

	Coverselle.find('.box.active item').each ->
		item = jQuery(this)
		item.prepend('<album-shade></album-shade>')
		image = item.data('image')
		item.css('background-image', 'url('+image+')')
		item.mouseenter -> itemShow(this)
		item.mouseleave -> itemHide(this)


placeBox = (codedData,status) ->

	params = JSON.parse codedData

	Coverselle = jQuery('.Coverselle#'+params.object)
	Coverselle.data('token',params.token)
	go = params.go
	left = go=='next' and '100%' or '-100%'
	right = go!='next' and '100%' or '-100%'

	Coverselle.find('.go.waiting').removeClass('waiting')


	# if Coverselle.data('waitingTimer')
	# 	clearTimeout Coverselle.data('waitingTimer')
	# 	Coverselle.data('waitingTimer',null)

	boxOld = Coverselle.find('.box')
	boxOld.removeClass('active').addClass('old')

	Coverselle.append('<div class="box new active" class="'+go+'" style="left: '+left+';"></div>')

	boxNew = Coverselle.find('.box.new')
	# boxNew.css('opacity',0)

	itemsCount = Coverselle.data('ShowItems')

	count = 0
	while count < itemsCount
		break unless params.items[count]
		dist = go=='next' and itemsCount+1-count or count
		item = """
			<item class="dist#{dist}" data-link="#{params.items[count].link}" data-image="#{params.items[count].cover}">
				<item-info>
					<item-artist>#{params.items[count].artist}</item-artist>
					<item-name>#{params.items[count].title}</item-name>
					<item-more><item-country>#{params.items[count].country}</item-country> / <item-label>#{params.items[count].label}</item-label></item-more>
					<item-more><item-format>#{params.items[count].format}</item-format> / <item-number>#{params.items[count].number}</item-number></item-more>
					<item-price>
						<span class="buttons">
							<button class="btn price"><b>#{params.items[count].price}</b> .</button>
							<button class="btn cart"><span class="glyphicon glyphicon-shopping-cart"></span></button>
						</span>
					</item-price>
				</item-info>
			</item>
		"""
		boxNew.append(item)
		count++

	initData(Coverselle)
	resize(Coverselle)

	# Coverselle.removeClass('waiting')
	Coverselle.css('background','none')

	boxOld.animate {
			'left': right
			# 'opacity': 0
		}, 500, ->
			boxOld.remove()
			# unless Coverselle.hasClass('waiting')
			# 	Coverselle.data('waitingTimer', setTimeout ->
			# 		Coverselle.addClass('waiting') 
			# 	, WaitingAnimationTimeout)

	boxNew.animate {
			'left': 0
			# 'opacity': 1
		}, 500, ->
			boxNew.removeClass('new')
	
	# console.info 'go', Coverselle.find('go').length

	unless Coverselle.find('.go').length
		Coverselle.append('<div class="go go-left"></div><div class="go go-right"></div>')
		Coverselle.find('.go-right').click -> loadNext(this,true)
		Coverselle.find('.go-left').click -> loadNext(this,false)

	if params.canGoBack
		Coverselle.find('.go-left').addClass('active')
	else 
		Coverselle.find('.go-left').removeClass('active')

	if params.canGoNext
		Coverselle.find('.go-right').addClass('active')
	else 
		Coverselle.find('.go-right').removeClass('active')

loadNext = (button,next=true) ->

	left = not next and '100%' or '-100%'
	go = next and 'next' or 'prev'

	buttonItem = jQuery(button)

	buttonItem.addClass('waiting')


	return unless buttonItem.hasClass('active')

	Coverselle = buttonItem.closest('.Coverselle')

	jQuery.get LoadUrl+'?object='+Coverselle.attr('id')+'&count='+Coverselle.data('ShowItems')+'&go='+go+'&token='+Coverselle.data('token'),
		placeBox

jQuery(window).resize ->

	jQuery('.Coverselle').each ->
		Coverselle = jQuery(this)
		evalShowItemsCount(Coverselle)
		resize(Coverselle)

jQuery ->

	CoverselleCount = 0
	jQuery('.Coverselle').each ->
		Coverselle = jQuery(this)
		++CoverselleCount
		evalShowItemsCount(Coverselle)
		Coverselle.attr('id','Coverselle'+CoverselleCount) unless Coverselle.attr('id')
		# unless Coverselle.hasClass('waiting')
		# 	Coverselle.data('waitingTimer', setTimeout ->
		# 		Coverselle.addClass('waiting') 
		# 	, WaitingAnimationTimeout)
		jQuery.get LoadUrl+'?object='+Coverselle.attr('id')+'&count='+Coverselle.data('ShowItems')+'&go=&token=',
			placeBox


